require 'drb'

module Borges

##
# Must be running with Apache so Borges can handle requests.

class ApacheDRbServer

  ##
  # Start up the DRb server

  def self.start(drb_uri)
    DRb.start_service(drb_uri, self.new())
  end

  ##
  # Install a SIGINT handler, so DRb will shut down cleanly on ctrl-c

  def self.install_INT_handler
    trap('INT') { DRb.stop_service; exit }
  end

  ##
  # Pass the request off to Borges for processing, returns the response.

  def handle_request(request)
    response = Response.new

    Borges::Application.handle_request(request, response)

    return response
  end

end # class ApacheDRbServer

end # module Borges

