require 'webrick'

module Borges

class WebrickConnection < WEBrick::HTTPServlet::AbstractServlet

  ##
  # WEBrick HTTP GET handler

  def do_GET(req, res)
    request = Request.new(req.path, req.query)
    response = Response.new
    Application.handle_request(request, response)
    res.status = response.status
    res.body = response.body
    response.headers.each do |k,v|
      res[k] = v
    end
  end

  ##
  # WEBrick HTTP POST handler (same as GET)

  def do_POST(request, response)
    do_GET(request, response)
  end
  
  def self.create(args = {})
    port = args[:Port] || 7000
    root = args[:Root] || "/"

    Borges.base_url = root

    @server = WEBrick::HTTPServer.new(:Port => port)
    @server.mount(root, self)
  end

  def self.mount(*args)
    @server.mount(*args)
  end

  def self.start(args = {})
    self.create(args) if @server.nil?
    trap("INT") do @server.shutdown end
    @server.start
  end
end

end

