#!/usr/bin/env ruby -w

require 'borges'
require 'borges/Page'

include Borges

##
# A simple counter example, using the Page class

class PageCounter < Page

  ##
  # Initialize @count

  def initialize
    @count = 0
    @title = "Page Counter"
  end
  
  ##
  # Called each time page is rendered, surrounded by
  # <html><head></head><body>...</body></html>

  def on_body(r)
    r.heading @count
    r.anchor("inc"){inc}
    r.space
    r.anchor("dec"){dec}
  end
  
  ##
  # Increment @count

  def inc() @count += 1 end

  ##
  # Decrement @count

  def dec() @count -= 1 end
end

Borges::register_application("counter2", PageCounter)

if $0 == __FILE__ then
  require 'borges/Webrick'

  Borges::WebrickConnection.start
end

