#require 'ask'
#require 'webask'
require 'renderask'

Route = Struct.new(:from, :to, :price, :seats)
class Route
  def to_s() "#{from} - #{to}" end
end

$routes = [
  Route.new("Vancouver, BC", "Seattle, WA", 23, 10),
  Route.new("Vancouver, WA", "Seattle, WA", 32, 20),
  Route.new("Vancouver, BC", "San Francisco, CA", 120, 1),
  Route.new("Seattle, WA", "Vancouver, BC", 23, 1),
  Route.new("Seattle, WA", "Vancouver, WA", 32, 10),
  Route.new("San Francisco, CA", "Vancouver, BC", 120, 40)
]

def book
  from = ask("Where are you travelling from?")
  to = ask("Where are you travelling to?")

  from = Regexp.new(from)
  to = Regexp.new(to)

  possible = $routes.reject { |r|
    from.match(r.from).nil? ||
    to.match(r.to).nil?
  }
  case possible.size
  when 0
    say "No matching routes."
    return
  when 1
    route = possible.first
  else
    say "These routes match: #{possible.join('  ')}.\n" + 
        "Please be more specific."
    return book()
  end
  
  passengers = ask("How many passengers?")
  passengers = passengers.to_i
  if(passengers > route.seats)
    say("Sorry, not enough seats.")
  else
    say("Total price: $%.2f" % (passengers * route.price))
  end
end

Borges.register_application("book", method(:book))
#book
Borges::WebrickConnection.start
